/* Switch branch utility command.     (R}hEvO)

   program and file name : switch.z.c
        bō쐬 OS-9/X680x0 p򃆁[eBeBEvO
      łBOS-9/680x0 ́A}[N̊֐@ɂ킹ĕύXĉ
      BȂAif.z R}hƋʐĂ܂B


   Copyright (c) 2000,          Izumi Geological Servey Office inc.
   All rights reserved.     Apr 2000,  Nagano prep, 399-6101, JAPAN
*/

#inclide <stdio.h>                /* printf() */
#include <stdlib.h>               /* exit() */
#include <string.h>               /* strncmp() */
#include <modes.h>                /* S_IREAD, S_IWRITE */

#define SIZE     1024             /* obt@ETCY@*/
#define HELP     "-?"             /* ₢킹(2oCg) */
#define OTHERS   "default"        /* ̑̕A<䕶> */
#define STDIN    0                /* W̓pX */
#define STDOUT   1                /* Wo̓pX@*/
#define STDERR   2                /* WG[o̓pX@*/
#define SAVE     0                /* J[\EZ[u */
#define RESTORE  1                /* J[\E[h@*/
#define OFF      0                /* tbO@*/
#define ON       -1               /*    "      */
#define NSNTX    22               /* -? ̕\s@*/

char
    wrkbf[SIZE],                   /* [NEobt@@*/
    dobuf[SIZE],
    tempbuf[SIZE],
    *sysmode,                      /* Xe[^X[h@*/
    *strmode,                      /* 񏈗[h@*/
    *outmode,                      /* o͌ʂ荞ރ[h@*/
    *cmnt,                         /* RgEAhX@*/
    *syntxcmt[NSNTX] = {           /* syntax ̓e@*/
       " [\] ",
       "\t 1. switch.z [<߼>] (<䖽>) <䕶> (<s>)",
       "\t 2. switch.z [<߼>]  <䕶> (<s>)",
       " [@\] ",
       "\t W̓pXǂݍ񂾕A͐䖽ߏIXe[^X",
       "\t Ȃǂw̐䕶ƂȂȂ΁As߂s܂B",
       "\t (<䖽>) () ܂߂ĂׂĂȗƁAW̓pX",
       "\t             ̓ǂݍ݂ƂȂ܂B",
       "\t  <䕶> vݒ肵܂BKvɉ\"\"",
       "\t             ͂܂Bdefault ͂ȊȌꍇłB",
       "\t (<s>)䕶ɑΉ閽߂ݒ肵܂B() ",
       "\t             ƕƂďo͂܂B",
       "\t     : <䕶><s>́AyAŗ񋓂Ȃ",
       "\t             ΂Ȃ܂B",
       "[IvV]",
       "\t -?       : gp@\B",
       "\t -s, o    : <䖽>̏IXe[^XAʂԂ܂B",
       "\t -l, m, r : Cӈʒu@ileft, middle, right)ł̍v",
       "\t             ̐łBftH[g͊SvłB",
       "\t             -l,m,r ݂Đݒ肷邱Ƃ͂ł܂B ",
       "\t -k       : [a-z,A-Z]̑召̑傫𖳎܂B",
       "\t -i       : Θb̈x̓ǂݍ݂ɐݒ肵܂B"
    },
    *errcomment[11] = {
       "IvVݒɌ肪܂B",              /* 1 */
       "`̃IvV܂B",                /* 2 */
       "p[^[Ɍ肪܂B",              /* 3 */
       "-l, -r, -m IvV͓ɐݒł܂B", /* 4 */
       "(<䖽>) ̂ -s ܂B",       /* 5 */
       "wȌIXe[^X܂B",        /* 6 */
       "wO̕G[܂B",          /* 7 */
       "VXeEG[܂B",              /* 8 */
       "<䖽>͏ȗł܂B",                  /* 9 */
       "-s, -o IvV͓ɐݒł܂ ",      /*10 */
       "<䖽>sł܂B"                   /*11 */
    };

int
    parampos,           /* ʒu@*/
    loption,            /* lߕ񍇒v */
    roption,            /* Elߕ񍇒v */
    moption,            /* Cӈʒuv@*/
    dialogue,           /* Θb */
    status,             /* Xe[^X@*/
    like;               /* CN̂悤ȁ@*/

void analyze(int, char **);
void worksyst(int, char **);
void workout(int, char **);
void workstring(int, char **);
void worknormal(int, char **);
int judgement(int, char **, char *);
void worksub(char *);
char *reset(register char *, char);
int mycmp(register char *, register char *);
int worksystsub(int, char *);
void lower(register char *);
void syntax(void);
int errorline(int);
void cursor(int);
void delright(void);

int main(int argc, char *argv[])
{
    int i;
    if (argc < 2 || argc == 2 && strcmp(argv[1], HELP) == 0)
        syntax();
    else {
        analyze(argc, argv);           /* ̉ */
        if (like == ON) {              /*  */
            for (i = parampos; i < argc; i += 2)
                lower(argv[i]);
        }
        if (sysmode != 0)
            worksyst(argc, argv);       /* IXe[^X */
        else if (outmode != 0)
            workout(argc, argv);        /* sʂ荞 */
        else if (strmode != 0)
            workstring(argc, argv);     /* 񏈗 */
        else
            worknormal(argc, argv);     /* ʏ폈 */
    }
    return 0;
}

void analyze(int argc, char *argv[ ])   /* ̉́@*/
{
    int i,j,kflag;
    char *p,*temp;
    sysmode = outmode = strmode = temp = 0;     /* ̂ */
    loption = roption = moption = kflag = OFF;
    parampos = 1;
    for (i = 1; i < argc; i += 1) {
        p = argv[i];
        if (*p == '-') {
            while (*(++p)) {
                switch (*p) {
                case 's':
                    sysmode = p;
                    break;
                case 'o':
                    outmode = p;
                    break;
                case 'c':
                    p++;
                    if (*p++ == '=') {
                        cmnt = reset(p, '\"');
                        p += (strlen(p) - 1);
                    } else
                        errorline(1);
                    break:
                case 'l':
                    loption = ON;
                    break;
                case 'r':
                    roption = ON;
                    break;
                case 'm':
                    moption = ON;
                    break;
                case 'i':
                    dialogue = ON;
                    break;
                case 'k':
                    like = ON;
                    break;
                default:
                    errorline(2);
                    break;
                }
            }
            parampos = i + 1;
         } else if (*p == '(' && kflag == OFF) {
            temp = p;
            kflag = ON;
            parampos = i + 1;
         } else
            break;
    }
    j = argc - i;
    if (j == 0 || (j % 2) != 0)
        errorline(3);
    if ((loption == ON || roption == ON) && moption == ON)
        errorline(4);
    if (loption == ON && roption == ON)
        errorline(4);
    if (kflag == OFF && sysmode != 0)
        errorline(5);
    if (sysmode != 0 outmode != 0)
        errorline(10);
    if (kflag == ON) {
        if (sysmode != 0)
            sysmode = reset(temp, '(');
        else if (outmode != 0)
            outmode = reset(temp, '(');
        else {
            strmode = reset(temp, '(');
            strmode = reset(strmode, '\"');
        }
    }
    for (i = parampos; i < argc; i += 2)
        argv[i] = reset(argv[i],'\"');
}

void worksyst(int argc, char *argv[])   /* IXe[^X@*/
{
    int i,code;
    code =system(sysmode);
    for (i = parampos; i < argc; i += 2) {    /* ݒl{ */
        if (strcmp(argv[i],OTHERS) == 0
                || worksystsub(code, argv[i]) == ON) {
            worksub(argv[i + 1]);
            break;
        }
    }
    if (i >= argc)
        errorline(6);
}

void workout(int argc, char *argv[])
{                                       /* 䖽߂̌ʂ荞ރ[h */
    int path,temp,len;
    sprintf(dobuf,"((%s) &)>>/ni1", outmode); /* sprintf()  >> ni1 */
    path = open("/pipe", S_IREAD | S_IWRITE); /* pCvp@path J@*/
    temp = dup(STDOUT);                       /* pX |  temp ɕ */  
    close(STDOUT);
    dup(path);
    if (system(dobuf) != 0)
        errorline(11);
    close(STDOUT);
    dup(temp);
    len = readln(path, wrkbf, SIZE);
    while (readln(path, tempbuf, SIZE))
        ;
    close(temp);
    close(path);
    wrkbf[len - 1] = '\0';
    if (judgement(argc, argv, wrkbf) >= argc)
        errorline(7);
}

void workstring(int argc, char *argv[])   /* 񏈗  */
{
     if (judgement(argc, argv, strmode) >= argc)
         errorline(7);
}

void worknormal(int argc, char *argv[])   /* ʏ폈@*/
{
     int flag,length;
     if (cmnt != NULL) {
         fprintf(stderr,"%s",cmnt);   /* Rg\ */
         fflush(stderr);
     }
     cursor(SAVE);
     fflush(stderr);
     length = 0;
     fgets(wrkbf, SIZE, stdin);
     while (! feof(stdin)){
         length = strlen(wrkbf);
         wrkbf[length - 1] = '\0';       /* ́@\n @*/
         flag = judgement(argc, argv, wrkbf);
         if (flag < argc && dialogue != OFF)
             break;
         if (dialogue != OFF) {          /* v܂ŗv */
             coursor(RESTORE);
             delright();
             fflush(stderr);
         }
         length = 0;
         fgets(wrkbf, SIZE, stdin);
    }
    if (dialogue != OFF && length == 0)
        fprintf(stderr,"\n");
}

int judgement(int argc, char *argv[], char *ptr)  /* v̌ */
{
    int i,result,len,l,flag;
    char *p;
    flag = OFF;
    if (roption == ON)
        len = strlen(ptr);
    for (i = parampos; i < argc; i += 2) {      /* { */
        if (strcmp(argv[i], OTHERS) == 0)       /* default */
            flag = ON;
        else if (moption == OFF) {
            strcpy(tempbuf, argv[i]);
            if (like == ON)
                lower(ptr);
            if (loption == ON) {                /* lߍv */
                if (mycmp(ptr, argv[i]) >= 0)
                    flag = ON;
            } else if (roption == OFF) {        /* Sv */
                if (mycmp(ptr, argv[i]) == 0)
                    flag = ON;
            } else {
                l = strlen(argv[i]);
                if (len >= l) {
                    p = ptr + len - l;
                    if (mycmp(p, argv[i]) == 0)
                        flag = ON;
                }
            }
        } else {                              /* Cӈʒu */
            if (like == ON)
                lower(ptr);
            if (findstr(1, ptr, argv[i]) > 0)
                flag = ON;
        }
        if (flag != OFF) {
            worksub(argv[i + 1]);
            break;
        }
    }
    return i;
}

void worksub(char *temp)                /* VF̎sA܂͏o */
{
    if (*temp == '(') {                 /* R}h@H */
        temp = reset(temp,'(');
        if ((status = system(temp)) != 0)
            erroline(8);
    } else                              /* @*/
        printf("%s\n",temp);
}

char *reset(register char *ptr, char t)
{                                       /* w蕶̍폜ƃAhXύX */
    register char *temp;
    if (*ptr == t) {
        if (*ptr == '(') {              /* '(' ̏ꍇ */
            while (*(++ptr) == ' ')     /* Xy[X̓XLbv */
                ;
            if (*ptr == '\0')           /* Xy[X݂̂̓G[ */
                errorline(9);
            temp = ptr + strlen(ptr) - 1;  /* ̈ʒuݒ肵@*/
            while (*(--temp) == ' ')    /* Xy[X̓XLbv@ */
                ;
            *(temp + 1) = '\0';         /*  '\0'  */
        } else {                        /* '(' ȊȌꍇ@*/
            *(ptr + strlen(ptr) - 1) = '\0';  /*  '\0'  */
            ptr++;                      /* |C^[𒲐@*/
        }
    }
    return ptr;
}

int mycmp(register char *s1, register char *s2) /* Ɛr֐@ */
{               /* *s1: r|C^[ij */
                /* *s2: r|C^[@i\j */@
    int flag;
    flag = 0;
    while (*s2 != '\0') {       /* r@i\j@!'\0' Ȃp */
        if (*s1++ != *s2++) {   /* Ȃ΁@*/
            flag = -1;          /* tbOZbgā@*/
            break;              /* [v𔲂 */
        }
    }
    if (flag == 0)              /* i\j͈̔͂œƂ@*/
        flag = ((*s2 == '\0' && *s1 == '\0') ? 0 : 1);
    retuen flag;                /* XɏڍוāA߂ */
}

int worksystsub(int code, char *p)
{
    int count,flag;
    register char *c;
    strcpy(tempbuf, p);
    c = tempbuf;
    count = 1;
    while (*c) {
        if (*c == '|') {            /* u|vŋ؂ */
            *c = '\0';
            cont += 1;
        }
        c++;
    }
    flag = OFF;
    c = tempbuf;
    do {
        if (code == atoi(c))
            flag = ON;
        else {
            count -= 1;
            if (count > 0) {
                while (*c)
                    c++;
                c++;
            }
        }
    } while (count > 0 && flag == OFF);
    return flag;
}

void lower(register char *s)
{
    register int c;
    while (*s) {
        c = *s;
        *s = ((c >= 'A' && c <= 'Z') ? c + 'a' - 'A' : c);
        s++;
    }
}

void syntax(void)
{
    int i;
    for (i = 0; i < NSNTX; i++)
        fprintf(stderr,"\t%s\n",syntxcmt[i]);
}

int errorline(int i)
{
    if (status > 10) {
        fprintf(stderr,"%s", errorcomment[i - 1]);
        exit(i + 10);
    } else
        exit(status);
}

/*   OS-9/680x0 ͋@ɂύXĉB  */

void cursor(int func)           /* J[\̃[hƃZ[u  */
{
    fprintf(stderr,"\x1b%s", func == SAVE ? "\x37 : "\x38");
}

void delright(void)             /* J[\E̍폜 */
{
    fprintf(stderr,"\x1b[K");
}

